package stream.dashboard;

import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import stream.Data;
import stream.Processor;

public class Table extends Widget implements Processor {

	static Logger log = LoggerFactory.getLogger(Table.class);

	/** The unique class ID */
	private static final long serialVersionUID = -4621014858060234283L;

	String[] keys;
	int maxRows = 10;
	final TableModel model = new TableModel();
	final JTable table;

	public Table() {
		super();
		table = new JTable(model);
		table.setBorder(new EmptyBorder(5, 5, 5, 5));
		JScrollPane scroll = new JScrollPane(table);
		scroll.setBorder(null);
		content.add(table);
	}

	public Table(int width, int height) {
		super(width, height);
		table = new JTable(model);
		table.setBorder(new EmptyBorder(5, 5, 5, 5));
		JScrollPane scroll = new JScrollPane(table);
		scroll.setBorder(null);
		content.add(table);
		table.setMinimumSize(content.getMinimumSize());
	}

	public Data process(Data input) {
		// log.info("processing {}", input);
		if (input == null)
			return input;

		if (!"AuditEventMessage".equalsIgnoreCase(input.get("@type") + ""))
			return input;

		model.add(input);
		return input;
	}

	public String[] getKeys() {
		return keys;
	}

	public void setKeys(String[] keys) {
		this.keys = keys;
		if (keys == null || keys.length == 0)
			model.getColumns().clear();
		else {
			for (String key : keys) {
				if (!key.trim().isEmpty()) {
					model.getColumns().add(key);
				}
			}
			model.fireTableStructureChanged();
		}
	}

	public boolean isResizable() {
		return true;
	}
}
