package stream.dashboard;

import java.util.ArrayList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import stream.Data;

public class TableModel extends AbstractTableModel {

	static Logger log = LoggerFactory.getLogger(TableModel.class);

	/** The unique class ID */
	private static final long serialVersionUID = 2948239776824429917L;

	int maxRows = 10;
	final List<Data> rows = new ArrayList<Data>();
	final List<String> columns = new ArrayList<String>();

	@Override
	public String getColumnName(int column) {
		// log.info("Returning column-name {}", column);
		return columns.get(column);
	}

	public int getRowCount() {
		return rows.size();
	}

	public int getColumnCount() {
		// log.info("Table has {} columns", columns.size());
		return columns.size();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		Data item = rows.get(rowIndex);
		return item.get(columns.get(columnIndex));
	}

	public void add(Data item) {
		rows.add(0, item.createCopy());
		while (rows.size() > maxRows) {
			rows.remove(rows.size() - 1);
		}
		// log.info("new data row added, firing change event...");
		fireTableDataChanged();
	}

	public int getMaxRows() {
		return maxRows;
	}

	public void setMaxRows(int maxRows) {
		this.maxRows = maxRows;
	}

	public List<String> getColumns() {
		return columns;
	}
}
